/*
 * 4mage Package
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the 4mage.co license that is
 * available through the world-wide-web at this URL:
 * https://4mage.co/license-agreement/
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade this extension to newer
 * version in the future.
 *
 * @category 	ForMage
 * @package 	ForMage_PriceTracker
 * @copyright 	Copyright (c) 2022 4mage.co (https://4mage.co/)
 * @license  	https://4mage.co/license-agreement/
 */

define(['jquery', 'priceUtils'], function ($, priceUtils) {
    'use strict';

    return function (SwatchRenderer) {
        $.widget('mage.SwatchRenderer', $['mage']['SwatchRenderer'], {

            options: {
                priceTrackerSelector: '.price-tracker',
            },

            _init: function () {
                this._super();
                this.showMinPrice();
            },

            _UpdatePrice: function () {
                this._super();
                this.showMinPrice();
            },

            showMinPrice: function () {

                var priceTracker = $(this.options.priceTrackerSelector);

                if (!priceTracker.length) {
                    return;
                }


                var configProductPrices = this.getProduct() ? this.options.jsonConfig.optionPrices[this.getProduct()] : null;

                if (configProductPrices && 'minPricePT' in configProductPrices) {

                    var amount = configProductPrices['minPricePT']['amount'];
                    if (amount === false) {
                        priceTracker.hide();

                    } else {
                        priceTracker.find('.price').text(priceUtils.formatPrice(amount, this.options.jsonConfig.currencyFormat));
                        priceTracker.show();
                    }

                } else if (this.options.jsonConfig.priceTracker.noOptions) {
                    priceTracker.find('.price').text(priceUtils.formatPrice(priceTracker.data('min-price'), this.options.jsonConfig.currencyFormat));
                    priceTracker.show();
                }

            }
        });
        return $['mage']['SwatchRenderer'];
    };

});